"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const hatchet_promise_1 = __importDefault(require("./hatchet-promise"));
describe('HatchetPromise', () => {
    it('should resolve the original promise if not canceled', () => __awaiter(void 0, void 0, void 0, function* () {
        const hatchetPromise = new hatchet_promise_1.default(new Promise((resolve) => {
            setTimeout(() => resolve('RESOLVED'), 500);
        }));
        const result = yield hatchetPromise.promise;
        expect(result).toEqual('RESOLVED');
    }));
    it('should resolve the cancel promise if canceled', () => __awaiter(void 0, void 0, void 0, function* () {
        const hatchetPromise = new hatchet_promise_1.default(new Promise((resolve) => {
            setTimeout(() => resolve('RESOLVED'), 500);
        }));
        const result = hatchetPromise.promise;
        setTimeout(() => {
            hatchetPromise.cancel();
        }, 100);
        try {
            yield result;
            expect(true).toEqual(false); // this should not be reached
        }
        catch (e) {
            expect(e).toEqual(undefined);
        }
    }));
});
